---
title: ReadableStream.pipeTo()
slug: Web/API/ReadableStream/pipeTo
tags:
  - API
  - Experimental
  - Method
  - ReadableStream
  - Reference
  - Streams
  - pipeTo
---
<div>{{SeeCompatTable}}{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>pipeTo()</code></strong> method of the {{domxref("ReadableStream")}} interface pipes the current <code>ReadableStream</code> to a given {{domxref("WritableStream")}} and returns a promise that fulfills when the piping process completes successfully, or rejects if any errors were encountered.</p>

<p>Piping a stream will generally lock it for the duration of the pipe, preventing other readers from locking it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>readableStream</em>.pipeTo(<em>destination</em>[, <em>options</em>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>destination</dt>
 <dd>A {{domxref("WritableStream")}} that acts as the final destination for the {{domxref("ReadableStream")}}.</dd>
 <dt>options {{optional_inline}}</dt>
 <dd>The options that should be used when piping to the <code>writable</code> stream. Available options are:
 <ol>
  <li><code>preventClose</code>: If this is set to <code>true</code>, the source <code>ReadableStream</code> closing will no longer cause the destination <code>WritableStream</code> to be closed. The method will return a fulfilled promise once this process completes, unless an error is encountered while closing the destination in which case it will be rejected with that error.</li>
  <li><code>preventAbort</code>: If this is set to <code>true</code>, errors in the source <code>ReadableStream</code> will no longer abort the destination <code>WritableStream</code>. The method will return a promise rejected with the source’s error, or with any error that occurs during aborting the destination.</li>
  <li><code>preventCancel</code>: If this is set to <code>true</code>, errors in the destination <code>WritableStream</code> will no longer cancel the source <code>ReadableStream</code>. In this case the method will return a promise rejected with the source’s error, or with any error that occurs during canceling the source. In addition, if the destination writable stream starts out closed or closing, the source readable stream will no longer be canceled. In this case the method will return a promise rejected with an error indicating piping to a closed stream failed, or with any error that occurs during canceling the source.</li>
  <li><code>signal</code>: If set to an <code><a href="/en-US/docs/Web/API/AbortSignal">AbortSignal</a></code> object, ongoing pipe operations can then be aborted via the corresponding <code><a href="/en-US/docs/Web/API/AbortController">AbortController</a></code>.</li>
 </ol>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves when the piping process has completed.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The <code>writableStream</code> and/or <code>readableStream</code> objects are not a writable stream/readable stream, or one or both of the streams are locked.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">// Fetch the original image
fetch('png-logo.png')
// Retrieve its body as ReadableStream
.then(response =&gt; response.body)
.then(body =&gt; body.pipeThrough(new PNGTransformStream()))
.then(rs =&gt; rs.pipeTo(new FinalDestinationStream()))</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#rs-pipe-to","pipeTo()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.ReadableStream.pipeTo")}}</p>
